#' @import mclust
#' @import combinat
#' @import mixAK
#' @import lme4
#' @import Matrix
#' @import Rcpp
#' @import ash
#' @import mvtnorm 
#' @import bayess 
#' @importFrom psych tr


Integratemix<-function(mix,equalcol,y.s,MCMC,burn){



if(equalcol=="TRUE"){


#------------------------------------------------------------
# Case a common variance-covariance matrix
#------------------------------------------------------------

#-------------------
# Initial values
#-------------------

n <- dim(y.s)[1] 
p <- dim(y.s)[2]
z = rep(0, n)
p <- dim(y.s)[2]
Mus <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
Sigma <- array(0, dim = c(dim(matrix(0, p, p)), MCMC))
Sn <- array(0, dim = c(dim(matrix(0,  p, p)), MCMC))
Ps <- array(0, dim = c(dim(matrix(0, 1, mix$k)), MCMC))
lik = matrix(0, n, mix$k)
lolik = rep(0, MCMC)
logpost = rep(0, MCMC)

n.z <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
y.b <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
mu.k <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
perms = matrix(unlist(permutas(mix$k)), ncol = mix$k, byrow = T)
nperms = dim(perms)[1]
empty.components2<-0

n.z.empty <- n.z 
n.z.empty2 <- n.z 

combina<-t(combn(mix$k, 2))
ncomb<-dim(combina)[1]
chibdeno <- 0
pen1 <- rep(0,MCMC)
Mus[,,1] <- mix$Mu0 
Sigma[,,1] <- mix$Sigma0 
Ps[,,1] <- mix$Ps0

empty.components <- 0

#-------------------------------------------------
# Gibbs Sampling
#-------------------------------------------------

for(s in 1:(MCMC-1)) {


#---------------------------------------------
# Update the latent variables
#---------------------------------------------

  for (t in 1:n) {
                  prob<-0
                  for(j in 1:mix$k){prob=c(prob,Ps[,j,s]*dmvnorm(y.s[t,],Mus[j,,s],Sigma[,,s]))}
                  prob<-prob[-1]
                  if (sum(prob) == 0) 
                  prob = rep(1, mix$k)
                  z[t] = sample(x = 1:mix$k, size = 1, prob = prob)
                 }


        for (j in 1:mix$k) {
            n.z[j,,s+1] = sum(z == j)

#------------------------------
# 2. Number of empty components
#------------------------------

            if(sum(n.z[j,,s+1]) != 0) y.b[j,,s+1] = apply(as.numeric(z == j) *y.s,2,sum)/n.z[j,,s+1]
            if(sum(n.z[j,,s+1]) == 0) y.b[j,,s+1] =  rep(0,p)
            if(sum(n.z[j,,s+1]) == 0) n.z.empty[j,,s+1] =  rep(1,p)
            if(sum(n.z[j,,s+1]) == 0) n.z.empty2[j,,s+1] =  rep(j,p)
            Sn[,,s+1] = Sn[,,s+1] + t(as.numeric(z == j)*(y.s-matrix(y.b[j,,s+1],n,p,byrow=TRUE)))%*%
                        (as.numeric(z == j)*(y.s-matrix(y.b[j,,s+1],n,p,byrow=TRUE)))+
                        t(y.b[j,,s+1]- mix$m)%*%(y.b[j,,s+1]-mix$m)*((n.z[j,,s+1])/(mix$g*n.z[j,,s+1]+1))[1]
            mu.k[j,,s+1] =  (mix$g*n.z[j,,s+1]*y.b[j,,s+1] + mix$m)/(mix$g*n.z[j,,s+1]+1)
        }




empty.components<-sum(apply(n.z.empty[,,s+1],1,sum))+empty.components

empty.components2<-c(sum(apply(n.z.empty[,,s+1],1,sum))/2,empty.components2)



#---------------------------------
# Updating component parameters 
#---------------------------------

          Sigma[,,s+1]<-solve(rWISHART(1, mix$nu+n, solve(solve(mix$S)+Sn[,,s+1]))) 
          Ps[,,s+1] <- rdirichlet(1, n.z[,1,s+1] + mix$alfa) 
          for (j in 1:mix$k) {
          Mus[j,,s+1]<- rmvnorm(1,mu.k[j,,s+1],(mix$g*Sigma[,,s+1])/(n.z[j,,s+1]*mix$g+1))
                            } 


#---------------------------------------------
# Compute the MAP using Gibbs output in the 
#---------------------------------------------            

ldmvnorm3<-function(theta){  # log mvn density

                           p<-theta[1]
                           y<-theta[2:(p+1)]
                           mu<-theta[(p+2):(2*p+1)]

                           c(  -(length(mu)/2)*log(2*pi) -.5*log(det(mix$g*(Sigma[,,s+1]))) -.5*
                           t(y-mu)%*%solve(mix$g*(Sigma[,,s+1]))%*%(y-mu)   )    
                           }

sum_k<-0

for (j in 1:mix$k) lik[, j] = Ps[,j,s+1] * dmvnorm(y.s,Mus[j,,s+1],Sigma[,,s+1])
                   lolik[s+1] = sum(log(apply(lik, 1, sum)))
                   logpost[s+1] = lolik[s+1]+sum(apply(cbind(p,Mus[,,s+1],matrix(0,mix$k,p)),1,ldmvnorm3))+
                                  dWISHART(solve(Sigma[,,s+1]), mix$nu, mix$S, log=TRUE)+
                                  sum((rep(mix$alfa,mix$k)-1)*log(Ps[,,s+1]))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))


for (j in 1:ncomb) sum_k <- log(t(Mus[combina[j,2],,s+1]-Mus[combina[j,1],,s+1])%*%solve(Sigma[,,s+1])%*%(Mus[combina[j,2],,s+1]-Mus[combina[j,1],,s+1])) + sum_k - log(mix$g)

pen1[s+1]<-sum_k


}


#---------------------------------------------
# Integrated Likelihood LPs
#---------------------------------------------

### log-component means 1

ldmvnorm<-function(theta){  # log mvn density
                          p<-theta[1]
                          y<-theta[2:(p+1)]
                          mu<-theta[(p+2):(2*p+1)]
                          c(  -(length(mu)/2)*log(2*pi) -.5*log(det(mix$g*(Sigma[,,max]))) -.5*
                          t(y-mu)%*%solve(mix$g*(Sigma[,,max]))%*%(y-mu)   )     
                          }

### log-component means 2

ldmvnorm2<-function(theta){  # log mvn density
                           p<-theta[1]
                           y<-theta[2:(p+1)]
                           mu<-theta[(p+2):(2*p+1)]
                           n.zs<-theta[(2*p+2):(3*p+1)]
                           dmvnorm(y,mu,(mix$g*(Sigma[,,max]))/(n.zs*mix$g+1),log=TRUE)  
                           }

#---------------------------------------------
# Chib's approximation
#---------------------------------------------
  
max=order(logpost[-(1:burn)])[MCMC-burn]+burn
lnum1=lolik[max]

lnum2=sum(apply(cbind(p,Mus[,,max],matrix(0,mix$k,p)),1,ldmvnorm))+
dWISHART(solve(Sigma[,,max]), mix$nu, mix$S, log=TRUE)+
sum((rep(mix$alfa,mix$k)-1)*log(Ps[,,max]))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))


chibdeno<-0

for(t in 1:(MCMC-burn)){
                        for (j in 1:nperms) chibdeno=  chibdeno + exp(sum(
                        sum(apply(cbind(p,Mus[perms[j,],,max],mu.k[,,burn+t],n.z[,,burn+t]),1,ldmvnorm2))+
                        dWISHART(solve(Sigma[,,max]), mix$nu+n, solve(Sn[,,burn+t]+solve(mix$S)), log=TRUE)+
                        sum((n.z[,1,burn+t] + mix$alfa - 1) * log(Ps[,perms[j,],max]))  + lgamma(sum(n.z[,1,burn+t] + mix$alfa)) - 
                        sum(lgamma(n.z[,1,burn+t] + mix$alfa))))
                        }



#------------------------------
# Integrated Likelihood LPs
#------------------------------

local.integrate<-lnum1+lnum2-log(chibdeno/((MCMC-burn)*nperms))

#---------------------------------------------
# Integrated Likelihood NLPs
#---------------------------------------------

pen_k_log2<-mean(exp(pen1[-(1:burn)]-log(mix$penalize)))
non.local.integrate<-local.integrate+log(pen_k_log2)

return(list(local.integrate=local.integrate,non.local.integrate=non.local.integrate))

}



if(equalcol=="FALSE"){

#------------------------------------------------------------
# Case a different variance-covariance matrix
#------------------------------------------------------------

#-------------------
# Initial values
#-------------------

n <- dim(y.s)[1] 
p <- dim(y.s)[2]
z = rep(0, n)
p <- dim(y.s)[2]
Mus <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
Ps <- array(0, dim = c(dim(matrix(0, 1, mix$k)), MCMC))
lik = matrix(0, n, mix$k)
lolik = rep(0, MCMC)
logpost = rep(0, MCMC)

n.z <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
y.b <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
mu.k <- array(0, dim = c(dim(matrix(0, mix$k, p)), MCMC))
perms = matrix(unlist(permutas(mix$k)), ncol = mix$k, byrow = T)
nperms = dim(perms)[1]


combina<-t(combn(mix$k, 2))
ncomb<-dim(combina)[1]
chibdeno <- 0
Mus[,,1] <- mix$Mu0 
Ps[,,1] <- mix$Ps0
Sigma <- array(0, dim = c(dim(matrix(0, p, mix$k*p)), MCMC))
Sn <- array(0, dim = c(dim(matrix(0, p, mix$k*p)), MCMC))
Sigma[,,1] <- mix$Sigma0
pen1 <- rep(0,MCMC)
pen2 <- rep(0,MCMC)


#-------------------------------------------------
# Gibbs Sampling
#-------------------------------------------------

for(s in 1:(MCMC-1)) {


#---------------------------------------------
# Update the latent variables
#---------------------------------------------

  for (t in 1:n) {
                  prob<-0
                  for(j in 1:mix$k){prob=c(prob,Ps[,j,s]*dmvnorm(y.s[t,],Mus[j,,s],Sigma[1:p,(p*j+1-p):(p*j),s]))}
                  prob<-prob[-1]
                  if (sum(prob) == 0) 
                  prob = rep(1, mix$k)
                  z[t] = sample(x = 1:mix$k, size = 1, prob = prob)
                 }


         for (j in 1:mix$k) {
                            n.z[j,,s+1] = sum(z == j)
                            if(sum(n.z[j,,s+1]) == 0) n.z[j,,s+1] = rep(1,p)
                            y.b[j,,s+1] = apply(as.numeric(z == j) *y.s,2,sum)/n.z[j,,s+1]
                            Sn[1:p,(p*j+1-p):(p*j),s+1] = t(as.numeric(z == j)*(y.s-matrix(y.b[j,,s+1],n,p,byrow=TRUE)))%*%
                                                          (as.numeric(z == j)*(y.s-matrix(y.b[j,,s+1],n,p,byrow=TRUE)))+
                                                          t(y.b[j,,s+1]- mix$m)%*%(y.b[j,,s+1]-mix$m)*((n.z[j,,s+1])/(mix$g*n.z[j,,s+1]+1))[1]
                            mu.k[j,,s+1] =  (mix$g*n.z[j,,s+1]*y.b[j,,s+1] + mix$m)/(mix$g*n.z[j,,s+1]+1)
                           }



#---------------------------------
# Updating component parameters 
#---------------------------------

          Ps[,,s+1] <- rdirichlet(1, n.z[,1,s+1] + mix$alfa) 
          for (j in 1:mix$k) {
                              Sigma[1:p,(p*j+1-p):(p*j),s+1]<-solve(rWISHART(1, mix$nu+n.z[j,1,s+1], solve(solve(mix$S)+Sn[1:p,(p*j+1-p):(p*j),s+1]))) 
                              Mus[j,,s+1]<- rmvnorm(1,mu.k[j,,s+1],(mix$g*Sigma[1:p,(p*j+1-p):(p*j),s+1])/(n.z[j,,s+1]*mix$g+1))
                            } 

#---------------------------------------------
# Compute the MAP using Gibbs output in the 
#---------------------------------------------            

sum_k <- 0
sum_k2 <- 0
post.j <- 0
Sigma.A.Inv<- matrix(0,p,p)

for (j in 1:mix$k){ 
                  lik[, j] = Ps[,j,s+1] * dmvnorm(y.s,Mus[j,,s+1],Sigma[1:p,(p*j+1-p):(p*j),s+1])
                  post.j = post.j +  dmvnorm(Mus[j,,s+1],mix$m,Sigma[1:p,(p*j+1-p):(p*j),s+1],log=TRUE) + 
                           dWISHART(solve(Sigma[1:p,(p*j+1-p):(p*j),s+1]), mix$nu, mix$S, log=TRUE)
                  Sigma.A.Inv = Sigma.A.Inv + solve(Sigma[1:p,(p*j+1-p):(p*j),s+1])

                  }
lolik[s+1] = sum(log(apply(lik, 1, sum)))
logpost[s+1] = lolik[s+1] + post.j +  sum((rep(mix$alfa,mix$k)-1)*log(Ps[,,s+1]))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))


            

for (j in 1:ncomb){ 
                   sum_k <- log(t(Mus[combina[j,2],,s+1]-Mus[combina[j,1],,s+1])%*%((Sigma.A.Inv/mix$k))%*%(Mus[combina[j,2],,s+1]-Mus[combina[j,1],,s+1])) + sum_k - log(mix$g)                  
                  }

for (j in 1:mix$k){ 
                  sum_k2 <- sum_k2  + dmvnorm(mu.k[j,,s+1],mix$m,mix$g*solve(Sigma.A.Inv/mix$k),log=TRUE) - dmvnorm(mu.k[j,,s+1],mix$m,mix$g*Sigma[1:p,(p*j+1-p):(p*j),s+1],log=TRUE)
                  }
 
pen2[s+1]<-sum_k2 
pen1[s+1]<-sum_k + sum_k2 

}


#---------------------------------------------
# Compute the MAP using Gibbs output in the 
#---------------------------------------------        

max=order(logpost[-(1:burn)])[MCMC-burn]+burn
lnum1=lolik[max]

lnum2 <- 0
sigmaks<-array(0, dim = c(dim(matrix(0, p, p)), mix$k))

for(j in 1:mix$k){
                  lnum2 = lnum2 + dmvnorm(mu.k[j,,max],mix$m,Sigma[1:p,(p*j+1-p):(p*j),max],log=TRUE) +
                          dWISHART(solve(Sigma[1:p,(p*j+1-p):(p*j),max]), mix$nu, mix$S, log=TRUE)
                  sigmaks[,,j] = Sigma[1:p,(p*j+1-p):(p*j),max]
                  }

lnum2 = lnum2 + sum((rep(mix$alfa,mix$k)-1)*log(Ps[,,max]))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))

#---------------------------------------------
# Chib's approximation
#---------------------------------------------

chibdeno<-0
chibdeno2<-0

for(t in 1:(MCMC-burn)){

for (j in 1:nperms){
                    chibdeno =  chibdeno + chibdeno2
                    sigma.p = sigmaks[,,perms[j,]]
                    sum.post = 0
                    for(m in 1:mix$k){
                                      sum.post = sum.post + dmvnorm(Mus[perms[j,m],,max],mu.k[m,,burn+t],(mix$g*(sigma.p[,,m]))/(n.z[m,,burn+t]*mix$g+1),log=TRUE) + 
                                                 dWISHART(solve(sigma.p[,,m]), mix$nu+n.z[m,1,burn+t], solve(Sn[1:p,(p*m+1-p):(p*m),burn+t]+solve(mix$S)), log=TRUE)
                   }

                     sum.post = sum.post + sum((n.z[,1,burn+t] + mix$alfa - 1) * log(Ps[,perms[j,],max]))  + lgamma(sum(n.z[,1,burn+t] + mix$alfa)) - 
                                sum(lgamma(n.z[,1,burn+t] + mix$alfa))
                     chibdeno2 = exp(sum.post)
                   }
                        }

#---------------------------------------------
# Integrated Likelihood LPs
#---------------------------------------------

local.integrate = lnum1+lnum2-log(chibdeno/((MCMC-burn)*nperms))
penk.local = mean(exp(pen2[-(1:burn)]))
local.integrate2 = log(penk.local) + local.integrate  

#------------------------------------
# Integrated Likelihood NLPs
#------------------------------------

pen_k_log2 = mean(exp(pen1[-(1:burn)]-log(mix$penalize)))
non.local.integrate = local.integrate+log(pen_k_log2)

return(list(local.integrate=local.integrate2,non.local.integrate=non.local.integrate))

}

}



