#' @import mclust
#' @import combinat
#' @import mixAK
#' @import lme4
#' @import Matrix
#' @import Rcpp
#' @import ash
#' @import mvtnorm 
#' @import bayess 
#' @importFrom psych tr




emLP<-function(mix,y.s,tol,equalcol){



if(equalcol=="TRUE"){

n <- dim(y.s)[1] 
p <- dim(y.s)[2]
z = matrix(0, n, mix$k)
p <- dim(y.s)[2]
n.z <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
Sn <- array(0, dim = c(dim(matrix(0,  p, p)), 1))
y.b <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
combina<-t(combn(mix$k, 2))
ncomb<-dim(combina)[1]
lik <- matrix(0, n, mix$k)
ok <- FALSE
mu.k.s <- mix$Mu
sigma.k <- mix$Sigma

#----------------------------------------------------------------
# log(post) - evaluation initial value
#----------------------------------------------------------------

ldmvnorm3<-function(theta){  # log mvn density

p<-theta[1]
y<-theta[2:(p+1)]
mu<-theta[(p+2):(2*p+1)]

       c(  -(length(mu)/2)*log(2*pi) -.5*log(det(mix$g*(mix$Sigma))) -.5*
            t(y-mu)%*%solve(mix$g*(mix$Sigma))%*%(y-mu)   )  
                             
}


for (j in 1:mix$k) lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma)
        lolik = sum(log(apply(lik, 1, sum)))
        log.post.0 = lolik+sum(apply(cbind(p,mix$Mu,matrix(0,mix$k,p)),1,ldmvnorm3))+
                       dWISHART(solve(mix$Sigma), mix$nu, mix$S, log=TRUE)+
                       sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))


#----------------------------------------------------------------
# Starting EM
#----------------------------------------------------------------

while(!ok){


#----------------------------------------------------------------
# probabilities for the missing data structure
#----------------------------------------------------------------

mu.k.s <- mix$Mu

for (t in 1:n){
              for(j in 1:mix$k){z[t,j]=mix$Ps[j] * dmvnorm(y.s[t,],mix$Mu[j,],mix$Sigma)}
              }

n.z.i<-apply(z/apply(z,1,sum),2,sum)
z<- z/apply(z,1,sum)

#----------------------------------------------------------------
# Statistics neccesary for the computations
#----------------------------------------------------------------

Sn <- array(0, dim = c(dim(matrix(0,  p, p)), 1))

         for (j in 1:mix$k) {
             n.z[j,,1] = rep(n.z.i[j],p)           
             if(n.z[j,1,1]<1) n.z[j,,1]=rep(1,p)
             y.b[j,,1] = apply(z[,j] *y.s,2,sum)/n.z[j,,1]
           Sn[,,1] = Sn[,,1] +  mix$g^(-1)*t(mix$Mu[j,]-mix$m)%*%(mix$Mu[j,]-mix$m) + 
                       t(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))%*%(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))
                           }


#----------------------------------------------------------------
# Component means
#----------------------------------------------------------------

for (j in 1:mix$k){

mix$Mu[j,]<-solve(solve(mix$Sigma)*(mix$g^(-1)+n.z.i[j]))%*%
(solve(mix$Sigma)%*%(n.z.i[j]*y.b[j,,1]))

}

#-------------------------------------
# Sigma and weigths component
#-------------------------------------

#-------------------------------------
# Updating parameters 
#-------------------------------------

          mix$Sigma <- (0.5*(solve(mix$S)+Sn[,,1]))/(0.5*(mix$nu-p+n+mix$k-1))
          mix$Ps <- (n.z[,2,1]+mix$alfa-1)/(n+mix$k*mix$alfa-mix$k)


#----------------------------------------------------------------
# Stoping  EM multivariate
#----------------------------------------------------------------


for (j in 1:mix$k) lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma)
        lolik = sum(log(apply(lik, 1, sum)))
        log.post = lolik+sum(apply(cbind(p,mix$Mu,matrix(0,mix$k,p)),1,ldmvnorm3))+
                       dWISHART(solve(mix$Sigma), mix$nu, mix$S, log=TRUE)+
                       sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))

if(abs(log.post-log.post.0)<tol) ok <- TRUE
log.post.0 <- log.post

}


return(list(Mu=mix$Mu,Sigma=mix$Sigma,P=mix$Ps,log.post=log.post,z=z))



}

if(equalcol=="FALSE"){

n <- dim(y.s)[1] 
p <- dim(y.s)[2]
z = matrix(0, n, mix$k)
p <- dim(y.s)[2]
n.z <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
y.b <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
combina<-t(combn(mix$k, 2))
ncomb<-dim(combina)[1]
lik <- matrix(0, n, mix$k)
ok <- FALSE
mu.k.s <- mix$Mu
sigma.k <- mix$Sigma
Sn <- array(0, dim = c(dim(matrix(0, p, mix$k*p)), 1))

#------------------------------------------
# log(post) - evaluation initial value
#------------------------------------------

post.j <- 0
Sigma.A.Inv<- matrix(0,p,p)

for (j in 1:mix$k) Sigma.A.Inv <- Sigma.A.Inv + solve(sigma.k[,,j])

Sigma.A.Inv<-Sigma.A.Inv/mix$k

for (j in 1:mix$k){ 
                  lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma[,,j])
                  post.j <- post.j +  dmvnorm(mix$Mu[j,],mix$m,mix$g*solve(Sigma.A.Inv),log=TRUE)
                  dWISHART(solve(mix$Sigma[,,j]), mix$nu, mix$S, log=TRUE)
                                     }
        lolik = sum(log(apply(lik, 1, sum)))
        log.post.0 = lolik + post.j + sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))


#----------------------------------------------------------------
# Starting EM
#----------------------------------------------------------------

while(!ok){


#----------------------------------------------------------------
# probabilities for the missing data structure
#----------------------------------------------------------------

mu.k.s <- mix$Mu

for (t in 1:n){
              for(j in 1:mix$k){z[t,j]=mix$Ps[j] * dmvnorm(y.s[t,],mix$Mu[j,],mix$Sigma[,,j])}
              }

n.z.i <- apply(z/apply(z,1,sum),2,sum)
z <- z/apply(z,1,sum)



#----------------------------------------------------------------
# Statistics neccesary for the computations
#----------------------------------------------------------------


         for (j in 1:mix$k) {
             n.z[j,,1] = rep(n.z.i[j],p)           
             if(n.z[j,1,1]<1) n.z[j,,1]=rep(1,p)
             y.b[j,,1] = apply(z[,j] *y.s,2,sum)/n.z[j,,1]
             Sn[1:p,(p*j+1-p):(p*j),1] =  (mix$g*mix$k)^(-1)*t(mix$Mu[j,]-mix$m)%*%(mix$Mu[j,]-mix$m) + 
                       t(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))%*%(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))
                       }

#----------------------------------------------------------------
# Component means
#----------------------------------------------------------------

for (j in 1:mix$k){

mix$Mu[j,]<-solve(mix$g^(-1)*Sigma.A.Inv+n.z.i[j]*solve(mix$Sigma[,,j]))%*%
(solve(mix$Sigma[,,j])%*%(n.z.i[j]*y.b[j,,1]))

}

#-------------------------------------
# Sigma and weigths component
#-------------------------------------

#-------------------------------------
# Updating parameters 
#-------------------------------------


          for(j in 1:mix$k) mix$Sigma[,,j] <- (0.5*(solve(mix$S)+Sn[1:p,(p*j+1-p):(p*j),1]))/(0.5*(mix$nu-p+n.z.i[j]))
         
          mix$Ps <- (n.z[,2,1]+mix$alfa-1)/(n+mix$k*mix$alfa-mix$k)


#----------------------------------------------------------------
# Stoping  EM multivariate
#----------------------------------------------------------------


Sigma.A.Inv <- matrix(0,p,p)

          for(j in 1:mix$k) Sigma.A.Inv <- Sigma.A.Inv + solve(sigma.k[,,j])

Sigma.A.Inv <- Sigma.A.Inv/mix$k


post.j <- 0

for (j in 1:mix$k){ 
                  lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma[,,j])
                  post.j <- post.j +  dmvnorm(mix$Mu[j,],mix$m,mix$g*solve(Sigma.A.Inv),log=TRUE)
                  dWISHART(solve(mix$Sigma[,,j]), mix$nu, mix$S, log=TRUE)
                                     }
        lolik = sum(log(apply(lik, 1, sum)))
        log.post = lolik + post.j + sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k))) 


if(abs(log.post-log.post.0)<tol) ok <- TRUE
log.post.0 <- log.post

}


return(list(Mu=mix$Mu,Sigma=mix$Sigma,P=mix$Ps,log.post=log.post,z=z))


}

}
