#' @import mclust
#' @import combinat
#' @import mixAK
#' @import lme4
#' @import Matrix
#' @import Rcpp
#' @import ash
#' @import mvtnorm 
#' @import bayess 
#' @importFrom psych tr


emNLP<-function(mix,y.s,tol,equalcol){


if(equalcol=="TRUE"){

n <- dim(y.s)[1] 
p <- dim(y.s)[2]
z = matrix(0, n, mix$k)
p <- dim(y.s)[2]
n.z <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
Sn <- array(0, dim = c(dim(matrix(0,  p, p)), 1))
y.b <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
combina<-t(combn(mix$k, 2))
ncomb<-dim(combina)[1]
lik <- matrix(0, n, mix$k)
ok <- FALSE
mu.k.s <- mix$Mu
sigma.k <- mix$Sigma

#------------------------------------------
# log(post) - evaluation initial value
#------------------------------------------

ldmvnorm3<-function(theta){  # log mvn density

p<-theta[1]
y<-theta[2:(p+1)]
mu<-theta[(p+2):(2*p+1)]

       c(  -(length(mu)/2)*log(2*pi) -.5*log(det(mix$g*(mix$Sigma))) -.5*
            t(y-mu)%*%solve(mix$g*(mix$Sigma))%*%(y-mu)   )  
                             
}


for (j in 1:mix$k) lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma)
        lolik = sum(log(apply(lik, 1, sum)))
        log.post.0 = lolik+sum(apply(cbind(p,mix$Mu,matrix(0,mix$k,p)),1,ldmvnorm3))+
                       dWISHART(solve(mix$Sigma), mix$nu, mix$S, log=TRUE)+
                       sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))


#------------------------------------------
# Starting EM
#------------------------------------------

while(!ok){


#-------------------------------------------------
# probabilities for the missing data structure
#-------------------------------------------------

mu.k.s <- mix$Mu

for (t in 1:n){
              for(j in 1:mix$k){z[t,j]=mix$Ps[j] * dmvnorm(y.s[t,],mix$Mu[j,],mix$Sigma)}
              }

n.z.i<-apply(z/apply(z,1,sum),2,sum)
z<- z/apply(z,1,sum)

#-------------------------------------------------
# Statistics neccesary for the computations
#-------------------------------------------------

Sn <- array(0, dim = c(dim(matrix(0,  p, p)), 1))

         for (j in 1:mix$k) {
             n.z[j,,1] = rep(n.z.i[j],p)           
             if(n.z[j,1,1]<1) n.z[j,,1]=rep(1,p)
             y.b[j,,1] = apply(z[,j] *y.s,2,sum)/n.z[j,,1]
             Sn[,,1] = Sn[,,1] +  mix$g^(-1)*t(mix$Mu[j,]-mix$m)%*%(mix$Mu[j,]-mix$m) + 
                       t(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))%*%(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))
                           }


#----------------------------------------------------------------
# Functions penalized terms numerator and denominator
#----------------------------------------------------------------

B.tj<-function(theta){

mal.dist<-t(theta)%*%solve(mix$Sigma)%*%(theta)

denom<-2*as.vector(mal.dist)*solve(mix$Sigma)-4*
(solve(mix$Sigma)%*%(theta))%*%t(solve(mix$Sigma)%*%(theta))

return(denom/as.vector(mal.dist)^2)

}


A.tj<-function(theta){

mal.dist<-t(theta)%*%solve(mix$Sigma)%*%(theta)

num<--2*(solve(mix$Sigma)%*%(theta))

return(num/as.vector(mal.dist))

}


#-----------------
# Component means
#-----------------

for (j in 1:mix$k){

sum_B.tj<-apply(mix$Mu[-j,]-matrix(mix$Mu[j,],mix$k-1,p,byrow=TRUE),1,B.tj)
B.t<-matrix(apply(sum_B.tj,1,sum),p,p,byrow=TRUE)
B.t


sum_A.tj<-apply(mix$Mu[-j,]-matrix(mix$Mu[j,],mix$k-1,p,byrow=TRUE),1,A.tj)
A.t<-apply(sum_A.tj,1,sum)
A.t

mix$Mu[j,]<-solve(solve(mix$Sigma)*(mix$g^(-1)+n.z.i[j])-B.t)%*%
(solve(mix$Sigma)%*%(n.z.i[j]*y.b[j,,1])+as.matrix(A.t)-B.t%*%mix$Mu[j,])



}

#------------------
# Sigma components
#------------------


A.ikt.old <- matrix(0,p,p)
A.ikt.new <- matrix(0,p,p)
num.new <- 0

for (j in 1:ncomb){ A.ikt.old <- (mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])%*%t(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])
                    num.new <- tr(solve(mix$Sigma)%*%(mu.k.s[combina[j,2],]-mu.k.s[combina[j,1],])%*%t(mu.k.s[combina[j,2],]-mu.k.s[combina[j,1],]))	
                    A.ikt.new <- A.ikt.old*(num.new)^(-1) + A.ikt.new
                   }   

#--------------------
# Updating parameters 
#--------------------

          mix$Sigma <- (0.5*(solve(mix$S)+Sn[,,1]) - A.ikt.new)/(0.5*(mix$nu-p+n+mix$k-1))
          mix$Ps <- (n.z[,2,1]+mix$alfa-1)/(n+mix$k*mix$alfa-mix$k)

#-------------------------
# Stoping  EM multivariate
#-------------------------

sum_k<-0

for (j in 1:ncomb) sum_k <- log(t(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])%*%solve(mix$Sigma)%*%(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])) + sum_k - log(mix$g) 

pen1<-sum_k


for (j in 1:mix$k) lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma)
        lolik = sum(log(apply(lik, 1, sum)))
        log.post = lolik+sum(apply(cbind(p,mix$Mu,matrix(0,mix$k,p)),1,ldmvnorm3))+
                       dWISHART(solve(mix$Sigma), mix$nu, mix$S, log=TRUE)+
                       sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))+
                       pen1-log(mix$penalize)


if(abs(log.post-log.post.0)<tol) ok <- TRUE
log.post.0 <- log.post

BIC.EM = lolik - 0.5*(mix$k*p + (mix$k-1) + 0.5*(p*(p+1)))*log(n)+                       
        sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))+
        pen1-log(mix$penalize)

}


return(list(Mu=mix$Mu,Sigma=mix$Sigma,P=mix$Ps,penalize=pen1-log(mix$penalize),log.post=log.post,BIC.EM=BIC.EM,z=z))




}

if(equalcol=="FALSE"){


n <- dim(y.s)[1] 
p <- dim(y.s)[2]
z = matrix(0, n, mix$k)
p <- dim(y.s)[2]
n.z <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
y.b <- array(0, dim = c(dim(matrix(0, mix$k, p)), 1))
combina<-t(combn(mix$k, 2))
ncomb<-dim(combina)[1]
lik <- matrix(0, n, mix$k)
ok <- FALSE
mu.k.s <- mix$Mu
sigma.k <- mix$Sigma
Sn <- array(0, dim = c(dim(matrix(0, p, mix$k*p)), 1))
mu.k.s <- mix$Mu

#------------------------------------------
# log(post) - evaluation initial value
#------------------------------------------

post.j <- 0
Sigma.A.Inv<- matrix(0,p,p)

for (j in 1:mix$k) Sigma.A.Inv <- Sigma.A.Inv + solve(sigma.k[,,j])

Sigma.A.Inv<-Sigma.A.Inv/mix$k

sum_k<-0

for (j in 1:ncomb) sum_k <- log(t(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])%*%Sigma.A.Inv%*%(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])) + sum_k - log(mix$g) 

pen1<-sum_k

for (j in 1:mix$k){ 
                  lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma[,,j])
                  post.j <- post.j +  dmvnorm(mix$Mu[j,],mix$m,mix$g*solve(Sigma.A.Inv),log=TRUE)
                  dWISHART(solve(mix$Sigma[,,j]), mix$nu, mix$S, log=TRUE)
                                     }
        lolik = sum(log(apply(lik, 1, sum)))
        log.post.0 = lolik + post.j + sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))+
                   pen1-log(mix$penalize)



#------------------------------------------
# Starting EM
#------------------------------------------

while(!ok){


#-------------------------------------------------
# probabilities for the missing data structure
#-------------------------------------------------



for (t in 1:n){
              for(j in 1:mix$k){z[t,j]=mix$Ps[j] * dmvnorm(y.s[t,],mix$Mu[j,],mix$Sigma[,,j])}
              }

n.z.i <- apply(z/apply(z,1,sum),2,sum)
z <- z/apply(z,1,sum)

#-------------------------------------------------
# Statistics neccesary for the computations
#-------------------------------------------------


         for (j in 1:mix$k) {
             n.z[j,,1] = rep(n.z.i[j],p)           
             if(n.z[j,1,1]<1) n.z[j,,1]=rep(1,p)
             y.b[j,,1] = apply(z[,j] *y.s,2,sum)/n.z[j,,1]
             Sn[1:p,(p*j+1-p):(p*j),1] =  (mix$k*mix$g)^(-1)*t(mix$Mu[j,]-mix$m)%*%(mix$Mu[j,]-mix$m) + 
                        t(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))%*%(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))

                       }

#----------------------------------------------------------------
# Functions penalized terms numerator and denominator
#----------------------------------------------------------------

B.tj<-function(theta){

mal.dist<-t(theta)%*%Sigma.A.Inv%*%(theta)

denom<-2*as.vector(mal.dist)*Sigma.A.Inv-4*
(Sigma.A.Inv%*%(theta))%*%t(Sigma.A.Inv%*%(theta))

return(denom/as.vector(mal.dist)^2)

}


A.tj<-function(theta){

mal.dist<-t(theta)%*%Sigma.A.Inv%*%(theta)

num<--2*(Sigma.A.Inv%*%(theta))

return(num/as.vector(mal.dist))

}


#-----------------
# Component means
#-----------------


for (j in 1:mix$k){

sum_B.tj<-apply(mu.k.s[-j,]-matrix(mu.k.s[j,],mix$k-1,p,byrow=TRUE),1,B.tj)
B.t<-matrix(apply(sum_B.tj,1,sum),p,p,byrow=TRUE)
B.t


sum_A.tj<-apply(mu.k.s[-j,]-matrix(mu.k.s[j,],mix$k-1,p,byrow=TRUE),1,A.tj)
A.t<-apply(sum_A.tj,1,sum)
A.t


mix$Mu[j,]<-solve(mix$g^(-1)*Sigma.A.Inv+n.z.i[j]*solve(mix$Sigma[,,j]) -B.t)%*%
(solve(mix$Sigma[,,j])%*%(n.z.i[j]*y.b[j,,1])+as.matrix(A.t)-B.t%*%mu.k.s[j,])


}

mu.k.s <- mix$Mu

#------------------
# Sigma components
#------------------


A.ikt.old <- matrix(0,p,p)
A.ikt.new <- matrix(0,p,p)
num.new <- 0

for (j in 1:ncomb){ A.ikt.old <- (mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])%*%t(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])
                    num.new <- tr(Sigma.A.Inv%*%(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])%*%t(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],]))	
                    A.ikt.new <- A.ikt.old*(num.new)^(-1)/mix$k + A.ikt.new
                   }   

         for (j in 1:mix$k) {
             n.z[j,,1] = rep(n.z.i[j],p)           
             if(n.z[j,1,1]<1) n.z[j,,1]=rep(1,p)
             y.b[j,,1] = apply(z[,j] *y.s,2,sum)/n.z[j,,1]
             Sn[1:p,(p*j+1-p):(p*j),1] =  (mix$k*mix$g)^(-1)*t(mix$Mu[j,]-mix$m)%*%(mix$Mu[j,]-mix$m) + 
                        t(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))%*%(z[,j]*(y.s-matrix(y.b[j,,1],n,p,byrow=TRUE)))

                       }



#--------------------
# Updating parameters 
#--------------------


          for(j in 1:mix$k) mix$Sigma[,,j] <- (0.5*(solve(mix$S)+Sn[1:p,(p*j+1-p):(p*j),1]) - A.ikt.new)/(0.5*(mix$nu-p+n.z.i[j]))
     
           mix$Ps <- (n.z[,2,1]+mix$alfa-1)/(n+mix$k*mix$alfa-mix$k)

#-------------------------
# Stoping  EM multivariate
#-------------------------


Sigma.A.Inv <- matrix(0,p,p)

          for(j in 1:mix$k) Sigma.A.Inv <- Sigma.A.Inv + solve(sigma.k[,,j])

Sigma.A.Inv <- Sigma.A.Inv/mix$k


sum_k<-0

for (j in 1:ncomb) sum_k <- log(t(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])%*%Sigma.A.Inv%*%(mix$Mu[combina[j,2],]-mix$Mu[combina[j,1],])) + sum_k - log(mix$g) 

pen1<-sum_k
post.j <- 0


for (j in 1:mix$k){ 
                  lik[, j] = mix$Ps[j] * dmvnorm(y.s,mix$Mu[j,],mix$Sigma[,,j])
                  post.j <- post.j +  dmvnorm(mix$Mu[j,],mix$m,mix$g*solve(Sigma.A.Inv),log=TRUE)
                  dWISHART(solve(mix$Sigma[,,j]), mix$nu, mix$S, log=TRUE)
                                     }
        lolik = sum(log(apply(lik, 1, sum)))
        log.post = lolik + post.j + sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k))) +
                   pen1-log(mix$penalize)



if(abs(log.post-log.post.0)<tol) ok <- TRUE
log.post.0 <- log.post

BIC.EM = lolik - 0.5*(mix$k*p + (mix$k-1) + 0.5*(p*(p+1)))*log(n)+                       
        sum((rep(mix$alfa,mix$k)-1)*log(mix$Ps))+lgamma(sum(rep(mix$alfa,mix$k)))-sum(lgamma(rep(mix$alfa,mix$k)))+
        pen1-log(mix$penalize)

}


return(list(Mu=mix$Mu,Sigma=mix$Sigma,P=mix$Ps,z=z))



}

}



